using Avalonia.Controls;
using Avalonia.Controls.Shapes;
using Avalonia.Interactivity;
using Avalonia.Media;
using HarfBuzzSharp;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;

namespace AvaloniaApplication1
{
    public struct InfoUser
    {
        public string surname;
        public string name;
        public string patronymic;
        public string gender;
        public string phone;
        public int dayBirth;
        public int monthBirth;
        public int yearBirth;
        public string weekDay;
        public string sign;

        public string Concat()
        {
            return surname + ";" + name + ";" + patronymic + ";" + gender + ";" + phone + ";" + dayBirth + ";" + monthBirth + ";" + yearBirth + ";" + weekDay + ";" + sign;
        }
    }
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        private void WriteFile(object sender, RoutedEventArgs e)
        {
            List<InfoUser> listUser = new List<InfoUser>();
            bool flag = true;
            try
            {
                Regex rSurname = new Regex("[-][-]{1,}");
                bool fSurname = rSurname.IsMatch(tbSurname.Text);
                if (fSurname == false)
                    flag = false;

                Regex rName = new Regex("[-][-]{0,}");
                bool fName = rName.IsMatch(tbName.Text);
                if (fName == false)
                    flag = false;

                Regex rPatr = new Regex("[-][-]{0,}");
                bool fPatr = rPatr.IsMatch(tbPatr.Text);
                if (fPatr == false)
                    flag = false;

                Regex rPhone = new Regex(@"^8(\d{3})\d{3}(\d{2}){2}$");
                bool fPhone = rPhone.IsMatch(tbPhone.Text);
                if (fPhone == false)
                    flag = false;
            }
            catch
            {
                flag = false;
            }
         
            if (flag == true)
            {
                string gender = "";
                if (rbPzh.IsChecked == true) gender = "";
                if (rbPm.IsChecked == true) gender = "";
                int year = Convert.ToInt32(tbYear.Text);
                int month = Convert.ToInt32(cbMonth.SelectedIndex);
                int day = Convert.ToInt32(tbDay.Text);
                DateTime date = new DateTime(year, month, day);
                string dayWeek = date.DayOfWeek.ToString();
                string sign = "";
                if ((day >= 24 && day <= 30 && month == 12) || (day <= 30 && month == 1)) sign = "";
                if ((day == 31 && month == 1) || (day >= 1 && day <= 28 && month == 2)) sign = "";
                if ((day >= 1 && day <= 31 && month == 3)) sign = "";
                if ((day >= 1 && day <= 30 && month == 4)) sign = "";
                if ((day >= 1 && day <= 14 && month == 5)) sign = "";
                if ((day >= 15 && day <= 31 && month == 5) || (day <= 2 && month == 6)) sign = "";
                if ((day >= 2 && day <= 12 && month == 6)) sign = "";
                if (((day >= 13 && day <= 30 && month == 6) || (day <= 6 && month == 7)) && (day != 24 && month == 6)) sign = "";
                if (day == 24 && month == 6) sign = " ";
                if ((day >= 7 && day <= 31 && month == 7)) sign = "";
                if ((day >= 1 && day <= 28 && month == 8)) sign = "";
                if ((day >= 29 && day <= 31 && month == 8) || (day <= 13 && month == 9)) sign = "";
                if ((day >= 14 && day <= 27 && month == 9)) sign = "";
                if ((day >= 28 && day <= 30 && month == 9) || (day <= 15 && month == 10)) sign = "";
                if ((day >= 16 && day <= 31 && month == 10) || (day <= 8 && month == 11)) sign = "";
                if ((day >= 9 && day <= 28 && month == 11)) sign = "";
                if ((day >= 29 && day <= 30 && month == 11) || (day <= 23 && month == 12)) sign = "";
                listUser.Add(new InfoUser
                {
                    surname = tbSurname.Text,
                    name = tbName.Text,
                    patronymic = tbPatr.Text,
                    gender = gender,
                    phone = tbPhone.Text,
                    dayBirth = day,
                    monthBirth = month,
                    yearBirth = year,
                    weekDay = dayWeek,
                    sign = sign
                });
                using (StreamWriter streamWriter = new StreamWriter("User.csv", true))
                {
                    foreach(InfoUser u in listUser)
                    {
                        streamWriter.WriteLine(u.Concat());
                    }
                }
                MessageWriteFile.IsVisible = true;
                MessageProblem.IsVisible = false;
            }
            else
            {
                MessageProblem.IsVisible = true;
                MessageWriteFile.IsVisible = false;
            }
        }
        public SolidColorBrush color(string gender)
        {
            switch (gender)
            {
                case "":
                    return new SolidColorBrush(Color.FromArgb(65, 176, 209, 249));
                case "":
                    return new SolidColorBrush(Color.FromArgb(65, 253, 196, 251));
                default:
                    return new SolidColorBrush(Color.FromRgb(0, 0, 0));
            }
        }
        private void ReadFile(object sender, RoutedEventArgs e)
        {
            MainPanel.IsVisible = false;
            ShowUsers.IsVisible = true;
            List<InfoUser> sortUser = new List<InfoUser>();
            using (StreamReader sr = new StreamReader("User.csv"))
            {
                string line = "";
                List<InfoUser> listUser = new List<InfoUser>();
                while (!sr.EndOfStream)
                {
                    line = sr.ReadLine();
                    string[] lineArray = line.Split(";");
                    listUser.Add(new InfoUser
                    {
                        surname = lineArray[0],
                        name = lineArray[1],
                        patronymic = lineArray[2],
                        gender = lineArray[3],
                        phone = lineArray[4],
                        dayBirth = Convert.ToInt32(lineArray[5]),
                        monthBirth = Convert.ToInt32(lineArray[6]),
                        yearBirth = Convert.ToInt32(lineArray[7]),
                        weekDay = lineArray[8],
                        sign = lineArray[9]
                    });
                }
                sortUser = listUser.OrderBy(x => x.surname).ToList();
            }
            File.Create("User.csv").Close();
            using (StreamWriter streamWriter = new StreamWriter("User.csv", true))
            {
                foreach (InfoUser u in sortUser)
                {
                    streamWriter.WriteLine(u.Concat());
                }
            }
            using (StreamReader sr = new StreamReader("User.csv"))
            {
                string line = "";
                while (!sr.EndOfStream)
                {
                    line = sr.ReadLine();
                    string[] lineArray = line.Split(";");
                    TextBlock tbFIO = new TextBlock()
                    {
                        Text = ": " + lineArray[0] + " " + lineArray[1] + " " + lineArray[2],
                    };
                    TextBlock tbGender = new TextBlock()
                    {
                        Text = ": " + lineArray[3],
                    };
                    TextBlock tbPhone = new TextBlock()
                    {
                        Text = ": " + lineArray[4],
                    };
                    TextBlock tbDataBirth = new TextBlock()
                    {
                        Text = " : " + lineArray[5] + "." + lineArray[6] + "." + lineArray[7],
                    };
                    TextBlock tbDayWeek = new TextBlock()
                    {
                        Text = "   : " + lineArray[8],
                    };
                    TextBlock tbSing = new TextBlock()
                    {
                        Text = "   : " + lineArray[9],
                    };

                    StackPanel spUser = new StackPanel();
                    spUser.HorizontalAlignment = Avalonia.Layout.HorizontalAlignment.Center;
                    spUser.Children.Add(tbFIO);
                    spUser.Children.Add(tbGender);
                    spUser.Children.Add(tbPhone);
                    spUser.Children.Add(tbDataBirth);
                    spUser.Children.Add(tbDayWeek);
                    spUser.Children.Add(tbSing);

                    Border border = new Border();
                    border.Background = color(lineArray[3]);
                    border.BorderBrush = Brushes.Indigo;
                    border.BorderThickness = new Avalonia.Thickness(2);
                    border.CornerRadius = new Avalonia.CornerRadius(50);
                    border.Margin = new Avalonia.Thickness(10);
                    border.Padding = new Avalonia.Thickness(20);

                    border.Child = spUser;
                    ShowUsers.Children.Add(border);
                }
            }
        }
        private void BackClick(object sender, RoutedEventArgs e)
        {
            ShowUsers.IsVisible = false;
            MainPanel.IsVisible = true;
        }
    }
}